using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.HttpsPolicy;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using Microsoft.OpenApi.Models;
using System.IO;
using Aurora.Core.EntityFramework;
using Microsoft.EntityFrameworkCore;
using Aurora.Common;

namespace Aurora.Core.Api
{
    public class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddHttpReports().AddHttpTransport(); 
            services.AddControllers();
            services.AddSwaggerGen(c =>
            {
                c.SwaggerDoc("v1", new OpenApiInfo { Title = "Aurora.Core.Api", Version = "v1" });
            });
            
            services.AddCommonService();
            services.AddModuleCoreApi(Configuration);

            services.AddSignalR();
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env,IHostApplicationLifetime lifetime)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
                app.UseSwagger();
                app.UseSwaggerUI(c => c.SwaggerEndpoint("/swagger/v1/swagger.json", "Aurora.Core.Api v1"));
            }
            app.UseHttpReports();

            app.UseHttpsRedirection();

            app.UseRouting();

            app.UseAuthorization();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapControllers();
            });
            // register this service
            // ServiceEntity serviceEntity = new ServiceEntity
            // {
            //     // IP = NetworkHelper.LocalIPAddress,
            //     Port = Convert.ToInt32(Configuration["Service:Port"]),
            //     ServiceName = Configuration["Service:Name"],
            //     ConsulIP = Configuration["Consul:IP"],
            //     ConsulPort = Convert.ToInt32(Configuration["Consul:Port"])
            // };

            // app.RegisterConsul(lifetime, serviceEntity);

                 app.UseEndpoints(endpoints =>
            {
                endpoints.MapControllers();
                endpoints.MapHub<TranslateRocketHub>("/hub/TranslateRocketHub");
            });

        }
    }
}
